# Stuff to be implemented externally :
Source10: kmodtool
%define   kmodtool sh %{SOURCE10}
# End stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.28-4}

%define kmod_name nvidia-legacy173xx
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)
%define kvariants PAE ""
%define upvar ""
%{!?kvariants: %define kvariants %{?upvar}}


Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>

Summary: 	Nvidia Display Driver kernel-module
Name: 		%{kmod_name}-kmod
Version: 	1.0.173.14.16
Release: 	1.%(echo %{kverrel} | tr - _)
Group: 		System/Kernel
License: 	Distributable
URL:        	http://www.nvidia.com/

#Source is created from these files:
# ftp://download.nvidia.com/XFree86/Linux-x86/1.0-8756/NVIDIA-Linux-x86-1.0-8762-pkg0.run
# ftp://download.nvidia.com/XFree86/Linux-x86_64/1.0-8756/NVIDIA-Linux-x86_64-1.0-8762-pkg2.run
Source0:	nvidia-glx-legacy173xx-kmod-data-%{version}.tar.bz2	
# Helper script to create SOURCE0 tarball from binary installer
Source200:	prep_nvidia-legacy173xx.sh
# fix compilation on 2.6.27 kernels
# taken from http://kanotix.com/files/173.14.12/NVIDIA_173.14.12_2.6.27.patch
Patch0:		NVIDIA_173.14.12_2.6.27.patch
ExclusiveArch:  i686
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# Require for rpm lzma compression transition
Requires:        rpm >= 4.4.2.3-1

Obsoletes:	kernel-module-nvidia

%description
This package provides Nvidia hardware accelerated OpenGL support
for Nvidia chipsets from Geforce2, Quadro4 or newer.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# To understand the magic better or to debug it, uncomment this :
#%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0

%ifarch %{ix86}
pushd nvidiapkg-x86/
# add global patches here :
#%patch0 -p0
popd
%else
pushd nvidiapkg-x64/
#%patch0 -p0
popd
%endif

for kvariant in %{kvariants} ; do
%ifarch %{ix86}
    cp -a nvidiapkg-x86 _kmod_build_$kvariant
%else
    cp -a nvidiapkg-x64 _kmod_build_$kvariant
%endif
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}
    pushd _kmod_build_$kvariant/usr/src/nv/
    ln -s -f Makefile.kbuild Makefile
    make SYSSRC="${ksrc}" module
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    install -D -m 0644 _kmod_build_$kvariant/usr/src/nv/nvidia.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}.%{_target_cpu}${kvariant:+.$kvariant}/extra/%{kmod_name}/nvidia.ko
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
%{__rm} -rf %{buildroot}


%changelog
* Fri Jan 30 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.16-1
- version update
* Mon Jan 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.15-3
- kernel 2.6.28-4
* Mon Jan 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.15-2
- kernel 2.6.28-3
* Sat Dec 27 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.15-1
- version update
- kernel 2.6.28-1
* Thu Dec 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.12-2
- kernel 2.6.28-1
* Tue Dec 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.0.173.14.12-1
- initial CCux package release
- based on kmod-nvidia package
- kernel 2.6.27-18
